class Zelle
{

  //--------------------------------------------------------------------------------------------------
  // Variabeln
  //--------------------------------------------------------------------------------------------------

  boolean fertig;
  int AnzahlBeruehrungen = 0;
  float [] Beruehrungspunkt = new float [4];           // von den max. 2 Berhrungspunkten werden die Koordinaten gespeichert
  color col;
  float xZelle;
  float yZelle;
  float rZelle;

  //--------------------------------------------------------------------------------------------------
  // Konstruktoren
  //--------------------------------------------------------------------------------------------------

  Zelle ()                                              // Konstruktor ohne Parametereingabe                
  {
    fertig = false;
    col = ZelleColor;
    int [] Position = freieStelle ();
    xZelle = Position [0];
    yZelle = Position [1];
    rZelle = 0;
  }


  //--------------------------------------------------------------------------------------------------
  // Methoden
  //--------------------------------------------------------------------------------------------------

  void zeichnen ()
  {
    ellipseMode (CENTER_RADIUS);
    noStroke ();
    fill (col);
    ellipse (xZelle, yZelle, rZelle, rZelle);
  }

  //--------------------------------------------------------------------------------------------------

  void loeschen ()
  {
    ellipseMode (CENTER_RADIUS);
    noStroke ();
    fill (Hintergrund);
    ellipse (xZelle, yZelle, rZelle, rZelle);
  }

  //--------------------------------------------------------------------------------------------------

  void wachsen ()
  {
    rZelle += f;
    zeichnen ();
  }

  //--------------------------------------------------------------------------------------------------

  int BeruehrungenZaehlen ()
  {
    AnzahlBeruehrungen = 0;

// Zellen

    for (int i=0; i<=n; i++)
    {
      float xNachbar = meineZelle [i].getGeometrie () [0];
      float yNachbar = meineZelle [i].getGeometrie () [1];
      float rNachbar = meineZelle [i].getGeometrie () [2];
      float Abstand = sqrt(sq(xNachbar - xZelle) + sq(yNachbar -yZelle));

      if (Abstand <= rZelle + minA + rNachbar && Abstand != 0)                                                          // Berhrung
      {
        setBerKoor (xZelle + (rZelle/Abstand)*(xNachbar - xZelle), yZelle + (rZelle/Abstand)*(yNachbar - yZelle));      // Koordinaten Berhrungspunkt setzen
      }
    }

// ffnungen

    for (int i=0; i < AnzahlOeffnungen; i++)
    {
      float xL = meineOeffnung [i].getGeometrie () [0];
      float xR = meineOeffnung [i].getGeometrie () [1];
      float yO = meineOeffnung [i].getGeometrie () [2];
      float yU = meineOeffnung [i].getGeometrie () [3];

      if (yZelle <= yU + rZelle + minA && yZelle >= yO - rZelle -minA && xZelle <= xR + rZelle + minA && xZelle >= xL - rZelle -minA)    // nur schlaufen, falls Berhrung mglich
      {
        if (yZelle <= yU && yZelle >= yO) {             // Berhrung links oder rechts
          if (xZelle < xL) {                            // Berhrung links
            setBerKoor (xL, yZelle);
          } 
          else if (xZelle > xR) {                       // Berhrung rechts
            setBerKoor (xR, yZelle);
          }
        } 
        else if (xZelle <= xR && xZelle >= xL) {        // Berhrung oben oder unten
          if (yZelle < yO) {                            // Berhrung oben
            setBerKoor (xZelle, yO);
          } 
          else if (yZelle > yU) {                       // Berhrung rechts
            setBerKoor (xZelle, yU);
          }
        } 
        else {                                                                     // Berhrung an einer Ecke
          if (sqrt(sq(xL - xZelle) + sq(yU -yZelle)) <= rZelle + minA) {           // Berhrung unten links
            setBerKoor (xL, yU);
          } 
          else if (sqrt(sq(xR - xZelle) + sq(yU -yZelle)) <= rZelle + minA) {      // Berhrung unten rechts
            setBerKoor (xR, yU);
          } 
          else if (sqrt(sq(xR - xZelle) + sq(yO -yZelle)) <= rZelle + minA) {      // Berhrung oben rechts
            setBerKoor (xR, yO);
          } 
          else if (sqrt(sq(xL - xZelle) + sq(yO -yZelle)) <= rZelle + minA) {      // Berhrung oben links
            setBerKoor (xL, yO);
          }
        }
      }

    }

// Rnder

    if (xZelle <= rZelle + minA) {                          // Berhrung links
      setBerKoor (0, yZelle);
    } else if (xZelle >= width - rZelle - minA) {           // Berhrung rechts
      setBerKoor (width, yZelle);
    } else if (yZelle <= rZelle + minA) {                   // Berhrung oben
      setBerKoor (xZelle, 0);
    } else if (yZelle >= height - rZelle - minA) {           // Berhrung rechts
      setBerKoor (xZelle, height);
    }
    
    return (AnzahlBeruehrungen);
  }

  //--------------------------------------------------------------------------------------------------

  void bewegen_Ber_1 ()
  {
    xZelle += f*(xZelle - Beruehrungspunkt [0])/rZelle;              // Mittelpunkt verschieben
    yZelle += f*(yZelle - Beruehrungspunkt [1])/rZelle;
  }

  //--------------------------------------------------------------------------------------------------

  void bewegen_Ber_2 ()
  {
    float xMitte = (Beruehrungspunkt [0] + Beruehrungspunkt [2])/2;
    float yMitte = (Beruehrungspunkt [1] + Beruehrungspunkt [3])/2;
    float AbstandMitte = sqrt(sq(xMitte -xZelle) + sq(yMitte -yZelle));
    xZelle += f*(AbstandMitte/rZelle)*((xZelle - xMitte)/AbstandMitte);              // Mittelpunkt verschieben
    yZelle += f*(AbstandMitte/rZelle)*((yZelle - yMitte)/AbstandMitte);
  }


  //--------------------------------------------------------------------------------------------------

  void setBerKoor (float x, float y)
  {
    AnzahlBeruehrungen++;
    if (AnzahlBeruehrungen<=2)
    {
      Beruehrungspunkt [AnzahlBeruehrungen*2-2] = x;    // x-Wert Berhrunspunkt
      Beruehrungspunkt [AnzahlBeruehrungen*2-1] = y;    // y-Wert Berhrunspunkt
    }
  }

  //--------------------------------------------------------------------------------------------------

  void reset ()
  {
    col = Hintergrund;                                           // Zelle lschen
    zeichnen ();

    fertig = false;                                              // Variabeln zurcksetzen
    col = ZelleColor;
    int [] Position = freieStelle ();
    xZelle = Position [0];
    yZelle = Position [1];
    rZelle = 0;
  }

  //--------------------------------------------------------------------------------------------------

  boolean getFertig ()                                // Variable "fertig" auslesen     
  {
    return fertig;
  }  

  //--------------------------------------------------------------------------------------------------  

  float [] getGeometrie ()                            // Geometrie auslesen
  {
    float [] Geometrie = {
      xZelle, yZelle, rZelle    };
    return Geometrie;
  }  

  //--------------------------------------------------------------------------------------------------

  void setFertig (boolean f)                           // Variable "fertig" setzen
  {
    fertig = f;
    col = ZelleFertigColor;
    zeichnen ();
  }    

  // --------------------------------------------------------------------------------------------------

  void setFarbe (color c)                              // Methode: Farbe setzen
  {
    col = c;
  }    

  //--------------------------------------------------------------------------------------------------

}
