import processing.core.*; import java.applet.*; import java.awt.*; import java.awt.image.*; import java.awt.event.*; import java.io.*; import java.net.*; import java.text.*; import java.util.*; import java.util.zip.*; public class _070103_Wachstum extends PApplet {//--------------------------------------------------------------------------
// Globale Variabeln
//--------------------------------------------------------------------------

int Hintergrund = color (230);                                 // Hintergrundfarbe
int ZelleColor = color (200, 200, 160);                        // Farbe wachsende Zelle
int ZelleFertigColor = color (200);                            // Farbe fertige Zelle
int FensterColor = color (0);                                  // Farbe Fenster
int AnzahlZellen = 400;                                          // Anzahl Zellen
int AnzahlOeffnungen = 4;                                        // Anzahl \u00d6ffnungen
int minRandAbstand = 50;                                         // minimaler Abstand einer \u00d6ffnung zum Rand
int n = 0;                                                       // Z\u00e4hler Durchg\u00e4nge
int m = 5;                                                       // Anzal Wachstumsrunden pro Durchgang
float f = 0.1f;                                                   // Wachstumsfaktor
int maxB = 120;                                                  // maximale Fensterbreite
int minB = 50;                                                   // minimale Fensterbreite
int minR = 5;                                                    // minimaler rZelle einer Zelle
int minA = 2;                                                    // minimaler Abstand, darunter = ber\u00fchrt
boolean schlaufen = false;                                       // draw stoppen/starten \u00fcber Mausklick (>s. Funktionen)
boolean alleGezeichnet = false;                                  // Ende ermitteln

Zelle [] meineZelle = new Zelle [AnzahlZellen];                  // Zellen-Array generieren
Oeffnung [] meineOeffnung = new Oeffnung [AnzahlOeffnungen];     // Oeffnungs-Array generieren

//--------------------------------------------------------------------------
// Initialisierung
//--------------------------------------------------------------------------

public void setup()
{
  size (600, 600);
  // frameRate (5);
  background (Hintergrund);

  meineOeffnung [0] = new Oeffnung (0, width/2, 0, height/2);                 // vier \u00d6ffnungen generieren
  meineOeffnung [1] = new Oeffnung (width/2, width, 0, height/2);
  meineOeffnung [2] = new Oeffnung (0, width/2, height/2, height);
  meineOeffnung [3] = new Oeffnung (width/2, width, height/2, height);

  for (int i=0; i<=3; i++) {                                                  // Oeffnungen zeichnen
    meineOeffnung [i].zeichnen ();
  }

  meineZelle [n] = new Zelle ();                                              // erste Zelle generieren
  meineZelle [n].zeichnen ();
  
  noLoop ();
}

//--------------------------------------------------------------------------
// Frame f\u00fcr Frame wiederholt
//--------------------------------------------------------------------------

public void draw ()
{

  for (int j = 1; j <= m; j++)                                             // m-mal wachsen, bevor eine neue Zelle generiert wird
  {

    for (int i = 0; i <= n; i++)                                           // alle bestehenden Zellen "durchschlaufen"
    {
      if (meineZelle [i].getFertig () == false)                            // falls die Zelle noch nicht fertig ist
      {
        int Beruehrungen = meineZelle [i].BeruehrungenZaehlen ();          // Zelle testen
        if (Beruehrungen == 0)                                             // keine Ber\u00fchrung -> wachsen
        {
          meineZelle [i].wachsen();
        }
        else if (Beruehrungen == 1)                                         // 1 Ber\u00fchrung -> bewegen
        {
          meineZelle [i].loeschen();
          meineZelle [i].bewegen_Ber_1();
          meineZelle [i].zeichnen();
        }
        else if (Beruehrungen == 2)                                         // 2 Ber\u00fchrung -> bewegen
        {
          meineZelle [i].loeschen();
          meineZelle [i].bewegen_Ber_2();
          meineZelle [i].zeichnen();
        }
        else if (Beruehrungen == 3)
        {
           if (meineZelle [i].getGeometrie () [2] < minR)                   // wird neu gestartet, falls sie fertig, aber zu klein ist
          {
            meineZelle [i].reset ();          
          }
          else                                                              // Zelle wird als "fertig" deklariert
          {
            meineZelle [i].setFertig (true);
          }
        }
      }
    }

  }


  if (n < AnzahlZellen-1)                      // Z\u00e4hler erh\u00f6hen und neue Zelle generieren, falls Anzahl Zellen noch nicht erreicht ist
  {
    n++;
    meineZelle [n] = new Zelle ();             // neue Zelle generieren
    meineZelle [n].zeichnen ();                // generierte Zelle zeichnen
  }
  else if (alleGezeichnet == false)
  {
    println ("alle Zellen gezeichnet");
    alleGezeichnet = true;
  }

}



public int [] freieStelle ()
{
  int [] zufallsPos = new int [2];

  int xRandom = (int) random (width);                              // freie Stelle suchen
  int yRandom = (int) random (height);
  boolean frei = false; 

  while (frei == false)
  {
    if ((get(xRandom, yRandom)) == Hintergrund)
    {
      frei = true;
    }
    else
    {
      xRandom = (int) random (width);
      yRandom = (int) random (height);
    }
  }
  zufallsPos [0] = xRandom;
  zufallsPos [1] = yRandom;
  return zufallsPos;
}

//--------------------------------------------------------------------------------------------------
 
public void mouseClicked()
{
  if (schlaufen == true)
  {
    noLoop ();
    schlaufen = false;
  } else if (schlaufen == false)
  {
    loop ();
    schlaufen = true;
  }
}

//--------------------------------------------------------------------------------------------------

public void keyPressed()                                                             // Programm neu starten
{
  background (Hintergrund);
  n = 0;                                                                      // n zur\u00fccksetzen

  meineOeffnung [0] = new Oeffnung (0, width/2, 0, height/2);                 // vier \u00d6ffnungen generieren
  meineOeffnung [1] = new Oeffnung (width/2, width, 0, height/2);
  meineOeffnung [2] = new Oeffnung (0, width/2, height/2, height);
  meineOeffnung [3] = new Oeffnung (width/2, width, height/2, height);

  for (int i=0; i<=3; i++) {                                                  // Oeffnungen zeichnen
    meineOeffnung [i].zeichnen ();
  }

  meineZelle [n] = new Zelle ();                                              // erste Zelle generieren
  meineZelle [n].zeichnen ();
  loop ();
  schlaufen = true;
  
}



class Oeffnung
{

  //--------------------------------------------------------------------------------------------------
  // Variabeln
  //--------------------------------------------------------------------------------------------------

  float x1;                // x-Wert links
  float x2;                // x-Wert rechts
  float y1;                // y-Wert oben
  float y2;                // y-Wert unten
  int col;               // Farbe

  //--------------------------------------------------------------------------------------------------
  // Konstruktoren
  //--------------------------------------------------------------------------------------------------

  Oeffnung (float l, float r, float o, float u)                    // Parameter: Parameter des Feldes der Oeffnung (links, rechts, oben, unten)
  {
    x1 = random (l + minRandAbstand, r - minRandAbstand - maxB);
    x2 = x1 + random (minB, maxB);
    y1 = random (o + minRandAbstand , u - minRandAbstand - maxB);
    y2 = y1 + random (minB, maxB);
  }

  //--------------------------------------------------------------------------------------------------
  // Methoden
  //--------------------------------------------------------------------------------------------------

  public void zeichnen ()
  {
    fill (FensterColor);
    rectMode(CORNERS);
    rect (x1, y1, x2, y2);
  }

//--------------------------------------------------------------------------------------------------  

  public float [] getGeometrie ()                            // Geometrie auslesen
  {
    float [] Geometrie = {x1, x2, y1, y2};
    return Geometrie;
  }  
  
//--------------------------------------------------------------------------------------------------


}

class Zelle
{

  //--------------------------------------------------------------------------------------------------
  // Variabeln
  //--------------------------------------------------------------------------------------------------

  boolean fertig;
  int AnzahlBeruehrungen = 0;
  float [] Beruehrungspunkt = new float [4];           // von den max. 2 Ber\u00fchrungspunkten werden die Koordinaten gespeichert
  int col;
  float xZelle;
  float yZelle;
  float rZelle;

  //--------------------------------------------------------------------------------------------------
  // Konstruktoren
  //--------------------------------------------------------------------------------------------------

  Zelle ()                                              // Konstruktor ohne Parametereingabe                
  {
    fertig = false;
    col = ZelleColor;
    int [] Position = freieStelle ();
    xZelle = Position [0];
    yZelle = Position [1];
    rZelle = 0;
  }


  //--------------------------------------------------------------------------------------------------
  // Methoden
  //--------------------------------------------------------------------------------------------------

  public void zeichnen ()
  {
    ellipseMode (CENTER_RADIUS);
    noStroke ();
    fill (col);
    ellipse (xZelle, yZelle, rZelle, rZelle);
  }

  //--------------------------------------------------------------------------------------------------

  public void loeschen ()
  {
    ellipseMode (CENTER_RADIUS);
    noStroke ();
    fill (Hintergrund);
    ellipse (xZelle, yZelle, rZelle, rZelle);
  }

  //--------------------------------------------------------------------------------------------------

  public void wachsen ()
  {
    rZelle += f;
    zeichnen ();
  }

  //--------------------------------------------------------------------------------------------------

  public int BeruehrungenZaehlen ()
  {
    AnzahlBeruehrungen = 0;

// Zellen

    for (int i=0; i<=n; i++)
    {
      float xNachbar = meineZelle [i].getGeometrie () [0];
      float yNachbar = meineZelle [i].getGeometrie () [1];
      float rNachbar = meineZelle [i].getGeometrie () [2];
      float Abstand = sqrt(sq(xNachbar - xZelle) + sq(yNachbar -yZelle));

      if (Abstand <= rZelle + minA + rNachbar && Abstand != 0)                                                          // Ber\u00fchrung
      {
        setBerKoor (xZelle + (rZelle/Abstand)*(xNachbar - xZelle), yZelle + (rZelle/Abstand)*(yNachbar - yZelle));      // Koordinaten Ber\u00fchrungspunkt setzen
      }
    }

// \u00d6ffnungen

    for (int i=0; i < AnzahlOeffnungen; i++)
    {
      float xL = meineOeffnung [i].getGeometrie () [0];
      float xR = meineOeffnung [i].getGeometrie () [1];
      float yO = meineOeffnung [i].getGeometrie () [2];
      float yU = meineOeffnung [i].getGeometrie () [3];

      if (yZelle <= yU + rZelle + minA && yZelle >= yO - rZelle -minA && xZelle <= xR + rZelle + minA && xZelle >= xL - rZelle -minA)    // nur schlaufen, falls Ber\u00fchrung m\u00f6glich
      {
        if (yZelle <= yU && yZelle >= yO) {             // Ber\u00fchrung links oder rechts
          if (xZelle < xL) {                            // Ber\u00fchrung links
            setBerKoor (xL, yZelle);
          } 
          else if (xZelle > xR) {                       // Ber\u00fchrung rechts
            setBerKoor (xR, yZelle);
          }
        } 
        else if (xZelle <= xR && xZelle >= xL) {        // Ber\u00fchrung oben oder unten
          if (yZelle < yO) {                            // Ber\u00fchrung oben
            setBerKoor (xZelle, yO);
          } 
          else if (yZelle > yU) {                       // Ber\u00fchrung rechts
            setBerKoor (xZelle, yU);
          }
        } 
        else {                                                                     // Ber\u00fchrung an einer Ecke
          if (sqrt(sq(xL - xZelle) + sq(yU -yZelle)) <= rZelle + minA) {           // Ber\u00fchrung unten links
            setBerKoor (xL, yU);
          } 
          else if (sqrt(sq(xR - xZelle) + sq(yU -yZelle)) <= rZelle + minA) {      // Ber\u00fchrung unten rechts
            setBerKoor (xR, yU);
          } 
          else if (sqrt(sq(xR - xZelle) + sq(yO -yZelle)) <= rZelle + minA) {      // Ber\u00fchrung oben rechts
            setBerKoor (xR, yO);
          } 
          else if (sqrt(sq(xL - xZelle) + sq(yO -yZelle)) <= rZelle + minA) {      // Ber\u00fchrung oben links
            setBerKoor (xL, yO);
          }
        }
      }

    }

// R\u00e4nder

    if (xZelle <= rZelle + minA) {                          // Ber\u00fchrung links
      setBerKoor (0, yZelle);
    } else if (xZelle >= width - rZelle - minA) {           // Ber\u00fchrung rechts
      setBerKoor (width, yZelle);
    } else if (yZelle <= rZelle + minA) {                   // Ber\u00fchrung oben
      setBerKoor (xZelle, 0);
    } else if (yZelle >= height - rZelle - minA) {           // Ber\u00fchrung rechts
      setBerKoor (xZelle, height);
    }
    
    return (AnzahlBeruehrungen);
  }

  //--------------------------------------------------------------------------------------------------

  public void bewegen_Ber_1 ()
  {
    xZelle += f*(xZelle - Beruehrungspunkt [0])/rZelle;              // Mittelpunkt verschieben
    yZelle += f*(yZelle - Beruehrungspunkt [1])/rZelle;
  }

  //--------------------------------------------------------------------------------------------------

  public void bewegen_Ber_2 ()
  {
    float xMitte = (Beruehrungspunkt [0] + Beruehrungspunkt [2])/2;
    float yMitte = (Beruehrungspunkt [1] + Beruehrungspunkt [3])/2;
    float AbstandMitte = sqrt(sq(xMitte -xZelle) + sq(yMitte -yZelle));
    xZelle += f*(AbstandMitte/rZelle)*((xZelle - xMitte)/AbstandMitte);              // Mittelpunkt verschieben
    yZelle += f*(AbstandMitte/rZelle)*((yZelle - yMitte)/AbstandMitte);
  }


  //--------------------------------------------------------------------------------------------------

  public void setBerKoor (float x, float y)
  {
    AnzahlBeruehrungen++;
    if (AnzahlBeruehrungen<=2)
    {
      Beruehrungspunkt [AnzahlBeruehrungen*2-2] = x;    // x-Wert Ber\u00fchrunspunkt
      Beruehrungspunkt [AnzahlBeruehrungen*2-1] = y;    // y-Wert Ber\u00fchrunspunkt
    }
  }

  //--------------------------------------------------------------------------------------------------

  public void reset ()
  {
    col = Hintergrund;                                           // Zelle l\u00f6schen
    zeichnen ();

    fertig = false;                                              // Variabeln zur\u00fccksetzen
    col = ZelleColor;
    int [] Position = freieStelle ();
    xZelle = Position [0];
    yZelle = Position [1];
    rZelle = 0;
  }

  //--------------------------------------------------------------------------------------------------

  public boolean getFertig ()                                // Variable "fertig" auslesen     
  {
    return fertig;
  }  

  //--------------------------------------------------------------------------------------------------  

  public float [] getGeometrie ()                            // Geometrie auslesen
  {
    float [] Geometrie = {
      xZelle, yZelle, rZelle    };
    return Geometrie;
  }  

  //--------------------------------------------------------------------------------------------------

  public void setFertig (boolean f)                           // Variable "fertig" setzen
  {
    fertig = f;
    col = ZelleFertigColor;
    zeichnen ();
  }    

  // --------------------------------------------------------------------------------------------------

  public void setFarbe (int c)                              // Methode: Farbe setzen
  {
    col = c;
  }    

  //--------------------------------------------------------------------------------------------------

}
static public void main(String args[]) {   PApplet.main(new String[] { "_070103_Wachstum" });}}